--[[
	Author: Alternator (Massiner of Nathrezim)
	Date:	2014

]]

local AddonName, AddonTable = ...;
local Engine = AddonTable.ButtonEngine;
local ScriptsBattlePetFavorite = Engine.ScriptsBattlePetFavorite;

local C = Engine.Constants;
local Core = Engine.Core;
local Util = Engine.Util;


--[[------------------------------------------------
	UpdateAction
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateAction(BFButton)

end


--[[------------------------------------------------
	Full Update
--------------------------------------------------]]
function ScriptsBattlePetFavorite.FullUpdate(BFButton)
	BFButton.IconTexture = GetSpellTexture(BFButton.BattlePetFavoriteSpellID);
	BFButton.ABWIcon:SetTexture(BFButton.IconTexture);	
	BFButton:UpdateUsable();
	
	if (GetMouseFocus() == BFButton.ABW) then
		BFButton.ABW:UpdateTooltip();
	end
end


--[[------------------------------------------------
	Icon
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateIcon(BFButton)

end


--[[------------------------------------------------
	Checked
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateChecked(BFButton)

end


--[[------------------------------------------------
	Usable
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateUsable(BFButton)
	Core.UpdateButtonUsable(BFButton, C_PetJournal.PetIsSummonable(BFButton.BattlePetGUID));
end


--[[------------------------------------------------
	Cooldown
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateCooldown(BFButton)
	CooldownFrame_Set(BFButton.ABWCooldown, C_PetJournal.GetSummonBattlePetCooldown());
end


--[[------------------------------------------------
	Tooltip
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateTooltip(ABW)
	GameTooltip_SetDefaultAnchor(GameTooltip, ABW);

	-- This next bit more or less lifted from the Pet Journal implementation
	local numPets, numOwned = C_PetJournal.GetNumPets();
	if ( numOwned > 0 and not C_PetBattles.IsInBattle()  ) then
		GameTooltip:SetCompanionPet(ABW.BFButton.BattlePetGUID);
	else
		GameTooltip:SetSpellByID(ABW.BFButton.BattlePetFavoriteSpellID);
	end
end


--[[------------------------------------------------
	Cursor
--------------------------------------------------]]
function ScriptsBattlePetFavorite.GetCursor(BFButton)
	return "battlepet", BFButton.BattlePetGUID, nil, nil;
end

